#version 120

#define PI 3.141592653589793238462643383279

varying vec4 swVertex;
uniform float swShadowBaseX;
uniform float swShadowBaseY;
uniform float swShadowDirectionX;
uniform float swShadowDirectionY;
uniform float swShadowLimitAngle;
uniform float swConeBrightness;

vec2 offset[8];

bool testshadow (vec2 checked) {
	vec2 base = vec2(swShadowBaseX, swShadowBaseY); // weapon base location
	vec2 direction = vec2(swShadowDirectionX, swShadowDirectionY); // wo+1 tac
	
	vec2 baseToVertex = checked - base;
	vec2 baseToDirection = direction - base;
	float lengthVertex = length(baseToVertex);
	float lengthDirection = length(baseToDirection);
	
	float vertexAngle = acos(dot(baseToVertex, baseToDirection) / (lengthVertex * lengthDirection));
	
	if (vertexAngle <= swShadowLimitAngle) {
		return true;
	} else {
		return false;
	}
}

void main() {
	int hits = 0;
	offset[0] = vec2(-0.707, -0.707);
	offset[1] = vec2(0.0, -1.0);
	offset[2] = vec2(0.707, -0.707);
	offset[3] = vec2(-1.0, 0.0);
	offset[4] = vec2(1.0, 0.0);
	offset[5] = vec2(-0.707, 0.707);
	offset[6] = vec2(0.0, 1.0);
	offset[7] = vec2(0.707, 0.707);
	
	for (int i=0; i<8; i++) {
		vec2 pos = (offset[i].xy*(3.0)) + swVertex.xy; // base sample position
		if (testshadow(pos)) {
			hits++;
		}
	}
	
	vec4 color = vec4(0.0, 0.0, 0.0, 0.0);
	if (hits > 0) {
		float multiplier = hits / 8.0;
		color = mix(vec4(0.3, 0.0, 0.0, 0.4), vec4(1.0, 0.7, 0.0, 0.8), multiplier * swConeBrightness);
	}
	gl_FragColor = color;
}
