#version 120

#define PI 3.141592653589793238462643383279

varying vec4 swVertex;
uniform float swShadowBaseX;
uniform float swShadowBaseY;
uniform float swShadowDirectionX;
uniform float swShadowDirectionY;
uniform float swShadowLimitAngle;
uniform float swConeBrightness;

vec2 offset[8];

bool testshadow (vec2 checked) {
	vec2 base = vec2(swShadowBaseX, swShadowBaseY); // weapon base location
	vec2 direction = vec2(swShadowDirectionX, swShadowDirectionY); // wo+1 tac
	
	vec2 baseToVertex = checked - base;
	vec2 baseToDirection = direction - base;
	float lengthVertex = length(baseToVertex);
	float lengthDirection = length(baseToDirection);
	
	float vertexAngle = acos(dot(baseToVertex, baseToDirection) / (lengthVertex * lengthDirection));
	
	if (vertexAngle <= swShadowLimitAngle) {
		return true;
	} else {
		return false;
	}
}

void main() {
	int hits = 0;
	offset[0] = vec2(-0.707, -0.707);
	offset[1] = vec2(0.0, -1.0);
	offset[2] = vec2(0.707, -0.707);
	offset[3] = vec2(-1.0, 0.0);
	offset[4] = vec2(1.0, 0.0);
	offset[5] = vec2(-0.707, 0.707);
	offset[6] = vec2(0.0, 1.0);
	offset[7] = vec2(0.707, 0.707);
	
	vec2 barberOffset = (swVertex.xy - vec2(swShadowBaseX, swShadowBaseY));
	float barberValue = pow(abs(sin(barberOffset.x * 0.04 + barberOffset.y * 0.02)), 8.0) * 0.75;
	
	for (int i=0; i<8; i++) {
		vec2 pos = (offset[i].xy*(3.0)) + swVertex.xy; // base sample position
		if (testshadow(pos)) {
			hits++;
		}
	}
	
	vec4 color = vec4(0.0, 0.0, 0.0, 0.0);
	if (hits > 0) {
		if (hits <= 6) {
			float multiplier = abs((hits) - 3.5) / 3.5;
			color = mix(vec4(0.9, 0.5, 0.0, 0.75), vec4(0.3, 0.0, 0.0, 0.4), multiplier);
		}
		if (hits > 3) {
			vec4 barberColor = mix(vec4(0.1, 0.0, 0.0, 0.1), vec4(0.9, 0.5, 0.0, 0.75), barberValue * swConeBrightness);
			color = vec4(color.rgb * color.a + barberColor.rgb * barberColor.a , color.a + barberColor.a);
		}
	}
	gl_FragColor = color;
}
