#version 120

#define PI 3.141592653589793238462643383279

varying vec4 swVertex;
uniform float swShadowBaseX;
uniform float swShadowBaseY;
uniform float swShadowDirectionX;
uniform float swShadowDirectionY;
uniform float swShadowLimitAngle;
uniform float swConeBrightness;

vec2 offset[8];

bool testshadow (vec2 checked) {
	vec2 base = vec2(swShadowBaseX, swShadowBaseY); // weapon base location
	vec2 direction = vec2(swShadowDirectionX, swShadowDirectionY); // wo+1 tac
	
	vec2 baseToVertex = checked - base;
	vec2 baseToDirection = direction - base;
	float lengthVertex = length(baseToVertex);
	float lengthDirection = length(baseToDirection);
	
	float vertexAngle = acos(dot(baseToVertex, baseToDirection) / (lengthVertex * lengthDirection));
	
	if (vertexAngle <= swShadowLimitAngle) {
		return true;
	} else {
		return false;
	}
}

void main() {
	vec4 color = vec4(0.0, 0.0, 0.0, 0.0);
	if (testshadow(swVertex.xy)) {
		color = mix(vec4(0.2, 0.0, 0.0, 0.2), vec4(0.55, 0.0, 0.0, 0.65), swConeBrightness);
	}
	gl_FragColor = color;
}
