#version 120

#define PI 3.141592653589793238462643383279

varying vec4 swVertex;
uniform float swShadeX;
uniform float swShadeY;
uniform float swShadeW;
uniform float swShadeH;
uniform float swShadeWindowW;
uniform float swShadeWindowH;
uniform float swShadeR;
uniform float swShadeG;
uniform float swShadeB;
uniform float swShadeAmin;
uniform float swShadeAmax;

void main() {

	float gradX = ((swVertex.x - swShadeX) / swShadeW);
	float gradY = ((swVertex.y - swShadeY) / swShadeH);
	
	float rg = 0.4 - pow(gradY, 1.0) * 0.1;
	
	//float alpha = mix(swShadeAmin, swShadeAmax, pow(gradY, 0.5));
	float alpha = 1.0; // dark shader just keeps the buttons opaque
	
	//int iY = int(swVertex.y);
	//float bonus = 1.0 - (0.15 * sin(swVertex.x / 6.25 + swVertex.y / 2.0));
	float bonus = 1.0 - (0.25 * sin(gradX + gradY));
	//float blue = 0.35 + 0.125 * gradY;
	float blue = rg + (0.05 * gradY);
	gl_FragColor = vec4(rg * bonus * swShadeR, rg * bonus * swShadeG, blue * bonus * swShadeB, alpha);
	
}
