#version 120

#define PI 3.141592653589793238462643383279

varying vec4 swVertex;
uniform float swShadeX;
uniform float swShadeY;
uniform float swShadeW;
uniform float swShadeH;
uniform float swShadeWindowW;
uniform float swShadeWindowH;
uniform float swShadeR;
uniform float swShadeG;
uniform float swShadeB;
uniform float swShadeAmin;
uniform float swShadeAmax;

void main() {

	float baseCoord = pow(pow(gl_FragCoord.x / swShadeWindowW, 2.0) + pow(((1.5*swShadeWindowH)+gl_FragCoord.y) / swShadeWindowH, 2.0), 0.5);
	float globalgradient = pow(clamp(sin(baseCoord * PI * 12.0), 0.0, 1.0), 1.4);

	float gradX = ((swVertex.x - swShadeX) / swShadeW);
	float gradY = ((swVertex.y - swShadeY) / swShadeH);
	
	float rg = 0.5 - pow(gradY, 1.0) * 0.1;
	
	//float alpha = mix(swShadeAmin, swShadeAmax, pow(gradY, 0.2));
	float alpha = 1.0;
	
	float buttonstructure = pow((
	
	  sin(((swVertex.x-swShadeX) * 1.4 + (swVertex.y-swShadeY)) / 1.2)
	  
	   + 1.0) / 2.6, 1.1);
	
	int iY = int(swVertex.y);
	//float bonus = 1.0 - (0.15 * sin(swVertex.x / 6.25 + swVertex.y / 2.0));
	float bonus = 1.0 - (0.25 * sin(gradX + gradY));
	//float blue = 0.35 + 0.125 * gradY;
	float blue = rg + 0.02 + (0.04 * gradY);
	rg += 0.2 * globalgradient;
	blue += 0.25 * globalgradient;
	rg -= buttonstructure * 0.014;
	blue -= buttonstructure * 0.014;
	gl_FragColor = vec4(rg * bonus * swShadeR, rg * bonus * swShadeG, blue * bonus * swShadeB, alpha);
	
}
