#version 120

uniform sampler2D tex;
uniform float swPixelSize;
uniform float swVertexPixelSize;
uniform float glowSize;
uniform float glowR;
uniform float glowG;
uniform float glowB;
uniform float texColorImpact;

vec2 offset[8];

void main(){

	vec2 trueCenter = gl_TexCoord[0].st;
	
	offset[0] = vec2(-0.707, -0.707);
	offset[1] = vec2(0.0, -1.0);
	offset[2] = vec2(0.707, -0.707);
	offset[3] = vec2(-1.0, 0.0);
	offset[4] = vec2(1.0, 0.0);
	offset[5] = vec2(-0.707, 0.707);
	offset[6] = vec2(0.0, 1.0);
	offset[7] = vec2(0.707, 0.707);

	float avgAlpha = 0.0;
	//float distanceSum = 0.0;
	for (int i=0; i<8; i++) {
		vec2 pos = (offset[i].xy*(swVertexPixelSize*glowSize)) + trueCenter; // base sample position
		// pos = vec2(round(pos.s / swPixelSize) * swPixelSize, round(pos.t / swPixelSize) * swPixelSize); // round to nearest true texel (pixellate)
		//float distance = sqrt(pow(abs(pos.s-trueCenter.s),2.0f)+pow(abs(pos.t-trueCenter.t),2.0f)); // get true distance for weighting
		//float distance = distance(pos, trueCenter);
		//distanceSum += 1.0f / distance;
		//avgAlpha += texture2D(tex, pos).a / distance;
		avgAlpha += texture2D(tex, pos).a;
	}
	avgAlpha /= 8.0f; // faster method, sufficient if we don't pixellate
	//avgAlpha /= distanceSum;
	
	vec4 texColor = texture2D(tex, trueCenter);
	
	
	vec3 texC = texColor.rgb;
	float texA = texColor.a;
	vec3 glowC = vec3(glowR, glowG, glowB);
	float glowA = pow(avgAlpha, 0.25f); // ramp up opacity
	//float glowA = avgAlpha;
	//float glowA = 0.05;
	
	float finalA = texA + (1.0 - texA) * glowA;
	//float finalA = (1.0 - texA) * glowA;
	//vec4 finalColor = vec4(glowC * (1.0 - texA), finalA);
	//vec4 finalColor = vec4(glowC, finalA);
	//vec4 finalColor = vec4(texC * texA + glowC * (1.0 - texA), finalA);
	
	texC = texC * gl_Color.rgb;
	//texA *= gl_Color.a;
	glowC = (texColorImpact * glowC * gl_Color.rgb) + (1.0 - texColorImpact) * glowC;
	
	vec4 finalColor = vec4(texC * texA + glowC * (1.0 - texA), finalA);
	
	gl_FragColor = finalColor;
}
