#version 120

uniform sampler2D tex;
uniform float swPixelSize;
uniform float swVertexPixelSize;
uniform float glowSize;
uniform float glowR;
uniform float glowG;
uniform float glowB;

vec2 offset[8];

void main(){

	vec2 trueCenter = gl_TexCoord[0].st;
	
	offset[0] = vec2(-0.707, -0.707);
	offset[1] = vec2(0.0, -1.0);
	offset[2] = vec2(0.707, -0.707);
	offset[3] = vec2(-1.0, 0.0);
	offset[4] = vec2(1.0, 0.0);
	offset[5] = vec2(-0.707, 0.707);
	offset[6] = vec2(0.0, 1.0);
	offset[7] = vec2(0.707, 0.707);
	
	float avgAlpha = 0.0;
	for (int i=0; i<8; i++) {
		vec2 pos = (offset[i].xy*(swVertexPixelSize*glowSize)) + trueCenter; // base sample position
		// check hardglow.frag for variant code
		avgAlpha += texture2D(tex, pos).a;
	}
	avgAlpha /= 8.0;
	
	vec4 texColor = texture2D(tex, trueCenter);
	
	vec3 texC = texColor.rgb;
	float texA = texColor.a;
	vec3 glowC = vec3(glowR, glowG, glowB);
	float glowA = pow(avgAlpha, 0.25f); // ramp up opacity
	
	//float finalA = texA + (1.0 - texA) * glowA;
	float finalA = (1.0 - texA) * glowA;
	vec4 finalColor = vec4(texC * texA + glowC * (1.0 - texA), finalA);
	
	gl_FragColor = finalColor;
}
