#version 120

#define PI 3.141592653589793238462643383279

varying vec4 swVertex;
uniform float swVertexCenterX;
uniform float swVertexCenterY;
uniform float swRadiusMin;
uniform float swRadiusMax;
uniform float swRadiusWidth;

void main() {
	
	vec2 center = vec2(swVertexCenterX, swVertexCenterY);
	
	float distance = distance(center, swVertex.xy);
	
	if (distance >= swRadiusMin && distance <= swRadiusMax) {
		float gradient = sin((distance - swRadiusMin) / swRadiusWidth * PI);
		gradient = (gradient * (1.0 - (1.0 / swRadiusWidth))) + (0.7 / swRadiusWidth); // lose interference (high-quality)
		float rg = 0.1 + (gradient * 0.5);
		float alpha = gradient * 0.4;
		gl_FragColor = vec4(rg, rg, rg * 0.85, alpha);
	} else {
		gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
	}
	
}
