#version 120

#define PI 3.141592653589793238462643383279

varying vec4 swVertex;
uniform float swVertexCenterX;
uniform float swVertexCenterY;
// uniform float swShadowSunRadius;
uniform float swShadowBaseX;
uniform float swShadowBaseY;
uniform float swShadowLimitAngle;

void main() {
	
	vec2 center = vec2(swVertexCenterX, swVertexCenterY); // sun
	vec2 base = vec2(swShadowBaseX, swShadowBaseY); // selected planet
	
	vec2 baseToSun = center - base;
	vec2 baseToVertex = swVertex.xy - base;
	float lengthVertex = length(baseToVertex);
	float lengthSun = length(baseToSun);
	
	float vertexAngle = acos(dot(baseToVertex, baseToSun) / (lengthVertex * lengthSun));
	
	if (vertexAngle <= swShadowLimitAngle && lengthVertex > lengthSun) {
		gl_FragColor = vec4(0.3, 0.0, 0.0, 0.4);
	} else {
		gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
	}
		
}
